#class auto
#memmap xmem
#define PORTA_AUX_IO


// WORKING STUFF SETUP

#define FAN_MIN		10
#define FAN_MAX		1024
#define HEATER_MIN	10
#define HEATER_MAX	1024


// TCP/IP SETUP

#define TCPCONFIG 0
#define USE_ETHERNET		1
#define MY_IP_ADDRESS   "192.168.1.55"
#define MY_NETMASK      "255.255.255.0"

#define MY_GATEWAY		"192.168.1.1" 		// only needed if out of local LAN

#use "dcrtcp.lib"
#use "http.lib"


int card,ambisi;
static unsigned int index,isfull;
static float tbuffer[256],rhbuffer[256];


void MsDelay ( int iDelay )
{
	unsigned long ul0;
	ul0 = MS_TIMER;		// get current timer value
	while ( MS_TIMER < ul0 + (unsigned long) iDelay );
}


//COLOR LCD SUPPORT


//----------------------------------------------------------------------------
//
//  File generated by S1D13706CFG.EXE
//
//  Copyright (c) 2000,2004 Epson Research and Development, Inc.
//  All rights reserved.
//
//  PLEASE NOTE: If you FTP this file to a non-Windows platform, make
//               sure you transfer this file using ASCII, not BINARY mode.
//
//----------------------------------------------------------------------------

// Panel: 320x240x8bpp 141Hz Color Single STN 8-bit (PCLK=12.500MHz) (Format 2)

#define S1D_DISPLAY_WIDTH           320
#define S1D_DISPLAY_HEIGHT          240
#define S1D_DISPLAY_BPP             8
#define S1D_DISPLAY_SCANLINE_BYTES  320
#define S1D_PHYSICAL_VMEM_ADDR      0x00000000L
#define S1D_PHYSICAL_VMEM_SIZE      0x14000L
#define S1D_PHYSICAL_REG_ADDR       0x00000000L
#define S1D_PHYSICAL_REG_SIZE       0x100
#define S1D_DISPLAY_PCLK            8000
#define S1D_PALETTE_SIZE            256
#define S1D_FRAME_RATE              90
#define S1D_POWER_DELAY_ON          50
#define S1D_POWER_DELAY_OFF         1200
#define S1D_REGDELAYOFF             0xFFFE
#define S1D_REGDELAYON              0xFFFF

#define S1D_WRITE_PALETTE(p,i,r,g,b)  \
{  \
    ((volatile S1D_VALUE*)(p))[0x0A/sizeof(S1D_VALUE)] = (S1D_VALUE)(r);  \
    ((volatile S1D_VALUE*)(p))[0x09/sizeof(S1D_VALUE)] = (S1D_VALUE)(g);  \
    ((volatile S1D_VALUE*)(p))[0x08/sizeof(S1D_VALUE)] = (S1D_VALUE)(b);  \
    ((volatile S1D_VALUE*)(p))[0x0B/sizeof(S1D_VALUE)] = (S1D_VALUE)(i);  \
}

#define S1D_READ_PALETTE(p,i,r,g,b)  \
{  \
    ((volatile S1D_VALUE*)(p))[0x0F/sizeof(S1D_VALUE)] = (S1D_VALUE)(i);  \
    r = ((volatile S1D_VALUE*)(p))[0x0E/sizeof(S1D_VALUE)];  \
    g = ((volatile S1D_VALUE*)(p))[0x0D/sizeof(S1D_VALUE)];  \
    b = ((volatile S1D_VALUE*)(p))[0x0C/sizeof(S1D_VALUE)];  \
}

typedef unsigned short S1D_INDEX;
typedef unsigned char  S1D_VALUE;

typedef struct
{
    S1D_INDEX Index;
    S1D_VALUE Value;
} S1D_REGS;

const static S1D_REGS aS1DRegs[] =
{
    {0x04,0x00},   // BUSCLK MEMCLK Config Register
    {0x05,0x32},   // PCLK Config  Register
    {0x10,0xD0},   // PANEL Type Register
    {0x11,0x00},   // MOD Rate Register
    {0x12,0x2B},   // Horizontal Total Register
    {0x14,0x27},   // Horizontal Display Period Register
    {0x16,0x00},   // Horizontal Display Period Start Pos Register 0
    {0x17,0x00},   // Horizontal Display Period Start Pos Register 1
    {0x18,0xFA},   // Vertical Total Register 0
    {0x19,0x00},   // Vertical Total Register 1
    {0x1C,0xEF},   // Vertical Display Period Register 0
    {0x1D,0x00},   // Vertical Display Period Register 1
    {0x1E,0x00},   // Vertical Display Period Start Pos Register 0
    {0x1F,0x00},   // Vertical Display Period Start Pos Register 1
    {0x20,0x87},   // Horizontal Sync Pulse Width Register
    {0x22,0x00},   // Horizontal Sync Pulse Start Pos Register 0
    {0x23,0x00},   // Horizontal Sync Pulse Start Pos Register 1
    {0x24,0x80},   // Vertical Sync Pulse Width Register
    {0x26,0x01},   // Vertical Sync Pulse Start Pos Register 0
    {0x27,0x00},   // Vertical Sync Pulse Start Pos Register 1
    {0x70,0x03},   // Display Mode Register
    {0x71,0x00},   // Special Effects Register
    {0x74,0x00},   // Main Window Display Start Address Register 0
    {0x75,0x00},   // Main Window Display Start Address Register 1
    {0x76,0x00},   // Main Window Display Start Address Register 2
    {0x78,0x50},   // Main Window Address Offset Register 0
    {0x79,0x00},   // Main Window Address Offset Register 1
    {0x7C,0x00},   // Sub Window Display Start Address Register 0
    {0x7D,0x00},   // Sub Window Display Start Address Register 1
    {0x7E,0x00},   // Sub Window Display Start Address Register 2
    {0x80,0x50},   // Sub Window Address Offset Register 0
    {0x81,0x00},   // Sub Window Address Offset Register 1
    {0x84,0x00},   // Sub Window X Start Pos Register 0
    {0x85,0x00},   // Sub Window X Start Pos Register 1
    {0x88,0x00},   // Sub Window Y Start Pos Register 0
    {0x89,0x00},   // Sub Window Y Start Pos Register 1
    {0x8C,0x4F},   // Sub Window X End Pos Register 0
    {0x8D,0x00},   // Sub Window X End Pos Register 1
    {0x90,0xEF},   // Sub Window Y End Pos Register 0
    {0x91,0x00},   // Sub Window Y End Pos Register 1
    {0xA0,0x00},   // Power Save Config Register
    {0xA1,0x00},   // CPU Access Control Register
    {0xA2,0x00},   // Software Reset Register
    {0xA3,0x00},   // BIG Endian Support Register
    {0xA4,0x00},   // Scratch Pad Register 0
    {0xA5,0x00},   // Scratch Pad Register 1
    {0xA8,0x00},   // GPIO Config Register 0
    {0xA9,0x80},   // GPIO Config Register 1
    {0xAC,0x00},   // GPIO Status Control Register 0
    {0xAD,0x00},   // GPIO Status Control Register 1
    {0xB0,0x00},   // PWM CV Clock Control Register
    {0xB1,0x00},   // PWM CV Clock Config Register
    {0xB2,0x00},   // CV Clock Burst Length Register
    {0xB3,0x00},   // PWM Clock Duty Cycle Register
};



#define S1DNUMREGS 54
#define S1DMEMSIZE 76800



/* VERSIONS FOR LONG ADDRESS */

#asm root
read13706::
		call addressbus		; put addresses and BHE
      ex de,hl
      ioe ld a,(hl)			; lee port paralelo
      ld h,0
      ld l,a
      ret

;sp+2: A0-A15
;sp+4: A16
;sp+6: data
write13706::
		call addressbus		; put addresses and BHE
		ld hl,(sp+6)			; lee dato
      ld a,l
      ex de,hl
      ioe ld (HL),a			; pone dato
      ret

;sp+2: return address for calling function
;sp+4: A0-A15
;sp+6: A16
;sp+8: data
addressbus:
		ld hl,(sp+4)			; lee address
      ex de,hl					; en DE
		ld hl,(sp+6)			; lee address A16
      ld a,l					; en A
ab2:  ld hl,PCDR				; apunta a port
      ioi res 4,(HL)			; A16=0
		rrca						; A16=1 ?
		jr nc,ok3	  			; no
      ioi set 4,(HL)			; s, A16=1
ok3:
		ld hl,PGDR				; apunta a port
		ioi ld (hl),d			; pone parte alta
		ld hl,PDDR				; apunta a port
		ioi set 7,(hl)			; A7=1 ?
      sla e
		jr c,oka7  				; s
      ioi res 7,(HL)			; no, A7=0
oka7:
		ioi set 6,(hl)			; A6=1 ?
      sla e
		jr c,oka6  				; s
      ioi res 6,(HL)			; no, A6=0
oka6:
		srl e						; restore e (A6=A7=0)
      srl e
      ld a,e
		ld hl,PBDR				; apunta a port paralelo
		ioi set 0,(hl)			; BHE=1
		rrca						; debo activar BHE ? (test A0=1)
		jr nc,okbhe	  			; no
      ioi res 0,(HL)			; s, BHE=0
okbhe:
      ld d,0x80				; I/O = 0x8000 + A5-A0 = 10000000 00xxxxxx
		ret


;IY: A0-A15
;A: A16
;(IX+0): data left
;(IX+1): data right
writew13706::
		ld a',a					; save A16
		ld hl,iy					; get A15-A0
      ex de,hl					; in DE
		call ab2					; put addresses and BHE
		ld a,(IX+0)				; lee dato
      ex de,hl
      ioe ld (HL),a			; pone dato
      ex af,af'				; restore A16
		ld hl,iy					; lee address
		ld	de,0x0001			; next byte
		add hl,de				; inc address
		adc a,d	  				; (adc a,0x00) propagate carry
      ex de,hl					; A15-A0 in DE
		ld a',a					; save A16
      call ab2					; address bus
      ex de,hl
		ld a,(IX+1)				; lee dato
      ioe ld (HL),a			; pone dato
      ex af,af'				; restore A16
      ret

xdumpblk::
		ld		a,xpc								; save the frame pointer, and xpc
		push	af
		push	ix

		ld		hl,(sp+12)						; Get mem address (long) in BC:DE
      ld		c,l
      ld		b,h
		ld		hl,(sp+10)
		ex		de,hl

		; Convert BC:DE to a normalized XMEM pointer
		call	LongToXaddr						; DE = logical address, A = xpc
		ld    xpc,a
      ex 	de,hl
  		ld		ix,hl								; IX = source


		ld		iy,(sp+6)						; a:iy=dest, hl=length
		ld		hl,(sp+8)
		ld		a,l
		ld		hl,(sp+14)

		ld		c,h								; c:b=length
		ld		b,l
		ex		af,af'
		ld		a,l
		or		a
		jr		nz,.xcbf_2
		dec	c
.xcbf_2:
		ex		af,af'

xcbf_loop:
      call	writew13706						; preserve BC,IX,IY,A
		ld		de,0x0002						; 6 copying word by word
		add	ix,de								; 4
		add	iy,de								; 4
		adc	a,d								; 2, (adc a,0x00) propagate carry
		djnz	xcbf_loop						; 5, critical path word
		dec	c
		jp		p,xcbf_loop

xcbf_done:
		pop	ix
		pop	af
		ld		xpc,a
		ret
#endasm



void writepalette(long paldata)
{
int i;
static unsigned char pbuf[3*256];
unsigned char *ptr;

	xmem2root(pbuf,paldata+sizeof(long),3*256);
   ptr=pbuf;
   BitWrPortI(PCDR,&PCDRShadow,0,2);					// M/R=0 => registers
	for(i=0;i<256;i++){
     write13706(0x08L,*ptr++);
	  write13706(0x09L,*ptr++);
	  write13706(0x0AL,*ptr++);
	  write13706(0x0BL,i);
   }
   BitWrPortI(PCDR,&PCDRShadow,1,2);					// M/R=1 => memory
}


void init13706()
{
int i;

   BitWrPortI(PCDR,&PCDRShadow,0,2);					// M/R=0 => registers
	for(i=1;i<S1DNUMREGS;i++)
   	write13706((long)(aS1DRegs[i].Index),aS1DRegs[i].Value);
   BitWrPortI(PCDR,&PCDRShadow,1,2);					// M/R=1 => memory
}

void LCD_fill(unsigned long address, unsigned long len, unsigned char color)
{
	while(len--)
     	write13706(address++,color);						// fill with color
}

#define LCD_clear() LCD_fill(0L,S1DMEMSIZE,0)


/* Plot image data, 1 pixel per byte, MSB left */

#define LCD_plot(x,y,color) write13706(320L*y+x,color)



/* Read image files, store them as [(long)lenght][data...] in xmem
Image data can be extracted from BMP format (without the header), but
vertically mirrored.
Take a desired image, resize to 320x240, color reduce to 256 colors,
mirror verticaly (rotate 180, flip horizontally).
Save to file, remove 1078 byte header with your preferred hex editor
Extract color palette from bytes 54-1077 (R G B 0) and reduce to R G B
*/

#ximport "frente.pbm" frente
#ximport "frente.pal" palette

#ximport "button0.pbm" button0
#ximport "button1.pbm" button1
#ximport "ledon.pbm" ledon
#ximport "ledoff.pbm" ledoff


root useix void LCD_dump(long imgdata, long paldata)
{

long dest;
unsigned int tocopy,len;


	len=S1DMEMSIZE/2;
   dest=0;
   imgdata+=sizeof(long);
   writepalette(paldata);
		while(len) {
			tocopy=2048-(int)(dest&2047);
			if(tocopy>len)
				tocopy=len;
			xdumpblk(dest,imgdata,tocopy);
			dest+=(tocopy<<1);
			imgdata+=(tocopy<<1);
			len-=tocopy;
		}

}

root useix void LCD_icon(long imgdata, int x, int y, int width, int height)
{

long dest;

// width must be even !!!

   dest=x+320L*y;
   imgdata+=sizeof(long);
	while(height--) {
			xdumpblk(dest,imgdata,width>>1);
			dest+=320L;
			imgdata+=width;
	}

}

// Bresenham Line Algorithm

void LCD_line(int x1,int y1,int x2,int y2, unsigned char color)
{
int  x,y,dx,dy,incx,incy,balance;

        if (x2 >= x1){
                dx = x2 - x1;
                incx = 1;
        }
        else {
                dx = x1 - x2;
                incx = -1;
        }

        if (y2 >= y1) {
                dy = y2 - y1;
                incy = 1;
        }
        else {
                dy = y1 - y2;
                incy = -1;
        }

        x = x1;
        y = y1;

        if (dx >= dy) {
                dy <<= 1;
                balance = dy - dx;
                dx <<= 1;

                while (x != x2) {
                        LCD_plot(x, y,color);
                        if (balance >= 0) {
                                y += incy;
                                balance -= dx;
                        }
                        balance += dy;
                        x += incx;
                }
                LCD_plot(x, y,color);
        }
        else {
                dx <<= 1;
                balance = dx - dy;
                dy <<= 1;

                while (y != y2) {
                        LCD_plot(x, y,color);
                        if (balance >= 0) {
                                x += incx;
                                balance -= dy;
                        }
                        balance += dx;
                        y += incy;
                }
                LCD_plot(x, y,color);
        }
}


#define LCD_rectangle(x1,y1,x2,y2,c) \
{ \
	LCD_line(x1,y1,x2,y1,c); \
	LCD_line(x2,y1,x2,y2,c); \
	LCD_line(x2,y2,x1,y2,c); \
	LCD_line(x1,y2,x1,y1,c); \
}



#use "6X8L.lib"
#use "12X16L.lib"

typedef struct {
	unsigned long *font;
	unsigned char	lpc;           // lines per character
	unsigned char	Bpcl;          // bytes per character line (1 or 2)
	unsigned char	bpcl;          // bits per character line
} FontInfo;

const static FontInfo fontinfo[]={
{&Font6x8,8,1,6},
{&Font12x16,16,2,12}
};

nodebug void LCD_putchr ( int font, unsigned long daddress, char chr , int color, int bcolor)
{
int i,j,ii,jj;
unsigned long address,dispaddress;
int data,aux;

	i=fontinfo[font].lpc;			// lines per character
	ii=fontinfo[font].Bpcl;			// bytes per character line
   jj=fontinfo[font].bpcl;			// bits per character line
	address=*(fontinfo[font].font)+i*ii*(chr-0x20);
   dispaddress=daddress;
	while(i--){
   	data=xgetint(address);
		aux=(data&0xFF)<<8;			// swap bytes
      data=((data>>8)&0xFF)+aux;
      address+=ii;
      j=jj;
      while(j--){
			if(data&0x8000)
				write13706(dispaddress,color);
      	else
         	if(bcolor>=0)				// bcolor =-1 => transparent
					write13706(dispaddress,bcolor);
         data<<=1;
         dispaddress++;
      }
	   dispaddress=daddress+=320;	// next line
	}
}

void LCD_printat (int font, unsigned int row, unsigned int col, char *ptr, int color, int bcolor)
{
unsigned long address;

  	address=320L*row;
	do {
   	address+=col;
		LCD_putchr (font,address,*ptr++,color,bcolor);
      col=fontinfo[font].bpcl;
	} 	while (*ptr);
}


// SHTxx SUPPORT ROUTINES


#define SHT_TMOUT 2000

typedef union
{ unsigned int i;
  float f;
} value;

enum {TEMP,HUMI};

#define	DATA   	3
#define	SCK   	0

#define noACK 0
#define ACK   1
                            //adr  command  r/w
#define STATUS_REG_W 0x06   //000   0011    0
#define STATUS_REG_R 0x07   //000   0011    1
#define MEASURE_TEMP 0x03   //000   0001    1
#define MEASURE_HUMI 0x05   //000   0010    1
#define RESET        0x1e   //000   1111    0

//----------------------------------------------------------------------------------
char s_write_byte(unsigned char value)
//----------------------------------------------------------------------------------
// writes a byte on the Sensibus and checks the acknowledge
{
unsigned char i,error;

  BitWrPortI (PDDR,&PDDRShadow,0,DATA );				// DATA =0
  for (i=0x80;i>0;i/=2)             //shift bit for masking
  { if (i & value)						//masking value with i
	    BitWrPortI (PDDDR,&PDDDRShadow,0,DATA );	 //write to SENSI-BUS DATA=1 (pull-up)
    else
	    BitWrPortI (PDDDR,&PDDDRShadow,1,DATA );  //write to SENSI-BUS DATA=0
    BitWrPortI (PCDR,&PCDRShadow,1,SCK ); //clk for SENSI-BUS
    BitWrPortI (PCDR,&PCDRShadow,0,SCK );
  }
  BitWrPortI (PDDDR,&PDDDRShadow,0,DATA ); //release DATA-line
  BitWrPortI (PCDR,&PCDRShadow,1,SCK ); //clk #9 for ack
  error=BitRdPortI(PDDR,DATA);          //check ack (DATA will be pulled down by SHT11)
  BitWrPortI (PCDR,&PCDRShadow,0,SCK );
  return error;                     //error=1 in case of no acknowledge
}

//----------------------------------------------------------------------------------
char s_read_byte(unsigned char ack)
//----------------------------------------------------------------------------------
// reads a byte form the Sensibus and gives an acknowledge in case of "ack=1"
{
  unsigned char i,val;

  val=0;
  BitWrPortI (PDDR,&PDDRShadow,0,DATA );				// DATA =0
  BitWrPortI (PDDDR,&PDDDRShadow,0,DATA ); //release DATA-line
  for (i=0x80;i>0;i/=2){	             //shift bit for masking
    BitWrPortI (PCDR,&PCDRShadow,1,SCK ); //clk for SENSI-BUS
    if (BitRdPortI(PDDR,DATA)) val=(val | i);        //read bit
    BitWrPortI (PCDR,&PCDRShadow,0,SCK );
  }
  BitWrPortI (PDDDR,&PDDDRShadow,ack,DATA ); //in case of "ack==1" pull down DATA-Line
  BitWrPortI (PCDR,&PCDRShadow,1,SCK ); //clk #9 for ack
  BitWrPortI (PCDR,&PCDRShadow,0,SCK );
  BitWrPortI (PDDDR,&PDDDRShadow,0,DATA ); //release DATA-line
  return val;
}

//----------------------------------------------------------------------------------
void s_transstart(void)
//----------------------------------------------------------------------------------
// generates a transmission start
//       _____         ________
// DATA:      |_______|
//           ___     ___
// SCK : ___|   |___|   |______
{

  BitWrPortI (PDDR,&PDDRShadow,0,DATA );				// DATA =0
  BitWrPortI (PDDDR,&PDDDRShadow,0,DATA );  //Initial state
  BitWrPortI (PCDR,&PCDRShadow,0,SCK );
  BitWrPortI (PCDR,&PCDRShadow,1,SCK );
  BitWrPortI (PDDDR,&PDDDRShadow,1,DATA );
  BitWrPortI (PCDR,&PCDRShadow,0,SCK );
  BitWrPortI (PCDR,&PCDRShadow,1,SCK );
  BitWrPortI (PDDDR,&PDDDRShadow,0,DATA );
  BitWrPortI (PCDR,&PCDRShadow,0,SCK );
}

//----------------------------------------------------------------------------------
void s_connectionreset(void)
//----------------------------------------------------------------------------------
// communication reset: DATA-line=1 and at least 9 SCK cycles followed by transstart
//       _____________________________________________________         ________
// DATA:                                                      |_______|
//          _    _    _    _    _    _    _    _    _        ___     ___
// SCK : __| |__| |__| |__| |__| |__| |__| |__| |__| |______|   |___|   |______
{
  unsigned char i;

  BitWrPortI (PDDR,&PDDRShadow,0,DATA );				// DATA =0
  BitWrPortI (PDDDR,&PDDDRShadow,0,DATA ); //Initial state
  BitWrPortI (PCDR,&PCDRShadow,0,SCK );
  for(i=0;i<9;i++)                  //9 SCK cycles
  {
  BitWrPortI (PCDR,&PCDRShadow,1,SCK );
  BitWrPortI (PCDR,&PCDRShadow,0,SCK );
  }
  s_transstart();                   //transmission start
}

//----------------------------------------------------------------------------------
char s_softreset(void)
//----------------------------------------------------------------------------------
// resets the sensor by a softreset
{

  s_connectionreset();              //reset communication
  return s_write_byte(RESET);       //send RESET-command to sensor
							  //=1 in case of no response from the sensor
}

//----------------------------------------------------------------------------------
char s_read_statusreg(unsigned char *p_value, unsigned char *p_checksum)
//----------------------------------------------------------------------------------
// reads the status register with checksum (8-bit)
{
  unsigned char error;
  s_transstart();                   //transmission start
  error=s_write_byte(STATUS_REG_R); //send command to sensor
  *p_value=s_read_byte(ACK);        //read status register (8-bit)
  *p_checksum=s_read_byte(noACK);   //read checksum (8-bit)
  return error;                     //error=1 in case of no response form the sensor
}

//----------------------------------------------------------------------------------
char s_write_statusreg(unsigned char *p_value)
//----------------------------------------------------------------------------------
// writes the status register with checksum (8-bit)
{
  unsigned char error;
  s_transstart();                   //transmission start
  error=s_write_byte(STATUS_REG_W);//send command to sensor
  error+=s_write_byte(*p_value);    //send value of status register
  return error;                     //error>=1 in case of no response form the sensor
}

//----------------------------------------------------------------------------------
cofunc char s_measure(unsigned char *p_value, unsigned char *p_checksum, unsigned char mode)
//----------------------------------------------------------------------------------
// makes a measurement (humidity/temperature) with checksum
{
  unsigned error;
  unsigned int i;
  static unsigned long timer;

  s_transstart();                   //transmission start
  error=0;
  switch(mode){                     //send command to sensor
    case TEMP: error=s_write_byte(MEASURE_TEMP);
    				break;
    case HUMI: error=s_write_byte(MEASURE_HUMI);
    				break;
    default  :
    				break;
  }
  timer=MS_TIMER;										// restart timeout
  while(BitRdPortI(PDDR,DATA)) {    //wait until sensor has finished the measurement
     if((MS_TIMER-timer)<SHT_TMOUT)
	  	  	yield;
     else return(error++);	 			// or timeout (~2 sec.) is reached
  }
  *(p_value+1)  =s_read_byte(ACK);    //read the first byte (MSB)
  *(p_value)=s_read_byte(ACK);    //read the second byte (LSB)
  *p_checksum =s_read_byte(noACK);  //read checksum
  return error;
}

//----------------------------------------------------------------------------------------
void calc_sht11(float *p_humidity ,float *p_temperature)
//----------------------------------------------------------------------------------------
// calculates temperature [C] and humidity [%RH]
// input :  humi [Ticks] (12 bit)
//          temp [Ticks] (14 bit)
// output:  humi [%RH]
//          temp [C]
{ const static float C1=-4.0;              // for 12 Bit
  const static float C2=+0.0405;           // for 12 Bit
  const static float C3=-0.0000028;        // for 12 Bit
  const static float T1=+0.01;             // for 14 Bit @ 5V
  const static float T2=+0.00008;           // for 14 Bit @ 5V

  float rh;             				// rh:      Humidity [Ticks] 12 Bit
  float t;					            // t:       Temperature [Ticks] 14 Bit
  float rh_lin;                     // rh_lin:  Humidity linear
  float rh_true;                    // rh_true: Temperature compensated humidity
  float t_C;                        // t_C   :  Temperature [C]

  rh=*p_humidity;
  t=*p_temperature;
  t_C=t*0.01 - 39.63;                  //calc. temperature from ticks to [C]
  rh_lin=C3*rh*rh + C2*rh + C1;     //calc. humidity from ticks to [%RH]
  rh_true=(t_C-25)*(T1+T2*rh)+rh_lin;   //calc. temperature compensated humidity [%RH]
  if(rh_true>100)rh_true=100;       //cut if the value is outside of
  if(rh_true<0.1)rh_true=0.1;       //the physical possible range

  *p_temperature=t_C;               //return temperature [C]
  *p_humidity=rh_true;              //return humidity[%RH]
}

//--------------------------------------------------------------------
float calc_dewpoint(float h,float t)
//--------------------------------------------------------------------
// calculates dew point
// input:   humidity [%RH], temperature [C]
// output:  dew point [C]
{ float logEx,dew_point;
  logEx=0.66077+7.5*t/(237.3+t)+(log10(h)-2);
  dew_point = (logEx - 0.66077)*237.3/(0.66077+7.5-logEx);
  return dew_point;
}


// TCP/IP CONFIG STUFF



int thi,t2hi,tlo,rhhi,rhlo;
float curT,curRH;

#ximport "index.shtml"   index_html
#ximport "admin.shtml"  admin_html
#ximport "ok.html"    	ok_html
#ximport "error.html"   err_html
#ximport	"rabbit1.gif"	rabbit1_gif

SSPEC_MIMETABLE_START
	SSPEC_MIME_FUNC(".shtml", "text/html", shtml_handler),
	SSPEC_MIME(".html", "text/html"),
	SSPEC_MIME(".gif", "image/gif"),
	SSPEC_MIME(".cgi", "")
SSPEC_MIMETABLE_END

int setup1(HttpState*);
int list(HttpState*);
void dolims();
void clrlims();

#define REDIRECTHOST		MY_IP_ADDRESS
#define REDIRECTTOK     "http://" REDIRECTHOST "/ok.html"
#define REDIRECTTOERR   "http://" REDIRECTHOST "/error.html"

// directorio del server, funciones y variables de SSI
SSPEC_RESOURCETABLE_START
	SSPEC_RESOURCE_XMEMFILE("/", index_html),
	SSPEC_RESOURCE_XMEMFILE("/index.shtml", index_html),
	SSPEC_RESOURCE_XMEMFILE("/admin.shtml", 	admin_html),
	SSPEC_RESOURCE_XMEMFILE("/rabbit1.gif", rabbit1_gif),
	SSPEC_RESOURCE_XMEMFILE("/ok.html", ok_html),
	SSPEC_RESOURCE_XMEMFILE("/error.html", err_html),
	SSPEC_RESOURCE_ROOTVAR("tlo", &tlo, INT16, "%d"),
	SSPEC_RESOURCE_ROOTVAR("thi", &thi, INT16, "%d"),
	SSPEC_RESOURCE_ROOTVAR("t2hi", &t2hi, INT16, "%d"),
	SSPEC_RESOURCE_ROOTVAR("rhlo", &rhlo, INT16, "%d"),
	SSPEC_RESOURCE_ROOTVAR("rhhi", &rhhi, INT16, "%d"),
	SSPEC_RESOURCE_ROOTVAR("curT", &curT, FLOAT32, "%5.1f"),
	SSPEC_RESOURCE_ROOTVAR("curRH", &curRH, FLOAT32, "%5.1f"),
	SSPEC_RESOURCE_FUNCTION("list", list),
	SSPEC_RESOURCE_FUNCTION("/setup1.cgi", setup1)
SSPEC_RESOURCETABLE_END


// parsing y decoding de la form
#define MAX_FORMSIZE	3
typedef struct {
	char *name;
	char value[MAX_FORMSIZE];
} FORMType;
FORMType FORMSpec[5];

void parse_token(HttpState* state)
{
	auto int i, len;

	for(i=0; i<HTTP_MAXBUFFER; i++) {
		if(state->buffer[i] == '=')
			state->buffer[i] = '\0';
	}
	state->p = state->buffer + strlen(state->buffer) + 1;

	for(i=0; i<(sizeof(FORMSpec)/sizeof(FORMType)); i++) {
		if(!strcmp(FORMSpec[i].name,state->buffer)) {
			len = (strlen(state->p)>MAX_FORMSIZE) ? MAX_FORMSIZE - 1: strlen(state->p);
			strncpy(FORMSpec[i].value,state->p,1+len);
			FORMSpec[i].value[MAX_FORMSIZE - 1] = '\0';
		}
	}
}

int parse_post(HttpState* state)
{
	auto int retval;

	while(1) {
		retval = sock_fastread(&state->s, state->p, 1);
		if(0 == retval) {
			*state->p = '\0';
			parse_token(state);

			return 1;
		}

		// should this only be '&'? (allow the eoln as valid text?)
		if((*state->p == '&') || (*state->p == '\r') || (*state->p == '\n')) {
			// found one token
			*state->p = '\0';
			parse_token(state);

			state->p = state->buffer;
		} else {
			state->p++;
		}

		if((state->p - state->buffer) > HTTP_MAXBUFFER) {
			// input too long
			return 1;
		}
	}

	return 0; // end of data - loop again to give it time to write more
}

int list(HttpState* state)
{
auto int printline;

	if(state->substate >= 10){
   	ambisi=0;
		return 1;
   }
	if(isfull) {
		printline = index-10-(state->substate);  //handle circular buffer
      if (printline<0)
      	printline+=256;
	}
   else {
   	if(state->substate >= index){
        	ambisi=0;
			return 1;
      }
		printline = index-(state->substate)-1;		// show backwards
   }

	sprintf(state->buffer, "<tr><td>%5.1f<td>%5.1f\r\n",tbuffer[printline],rhbuffer[printline]);
	state->headerlen = strlen(state->buffer);
	state->headeroff = 0;
	state->substate++;
   ambisi=1;
	return(0);
}


int setup1(HttpState* state)
{
char buffer[MAX_FORMSIZE];
unsigned int err;
int aux[5];

		FORMSpec[0].name = "tlo";
		FORMSpec[1].name = "thi";
		FORMSpec[2].name = "t2hi";
		FORMSpec[3].name = "rhlo";
		FORMSpec[4].name = "rhhi";
      for(err=0;err<5;err++)
			FORMSpec[err].value[0] = 0; 						// init form data
      err=1;
		if(parse_post(state)) {
			if(*(http_urldecode(buffer,FORMSpec[0].value,MAX_FORMSIZE))) { // decode data, ignore empty strings
            aux[0]=atoi(buffer);
				if(*(http_urldecode(buffer,FORMSpec[1].value,MAX_FORMSIZE))) { // decode data, ignore empty strings
	            aux[1]=atoi(buffer);
					if(*(http_urldecode(buffer,FORMSpec[2].value,MAX_FORMSIZE))) { // decode data, ignore empty strings
		            aux[2]=atoi(buffer);
						if(*(http_urldecode(buffer,FORMSpec[3].value,MAX_FORMSIZE))) { // decode data, ignore empty strings
			            aux[3]=atoi(buffer);
							if(*(http_urldecode(buffer,FORMSpec[4].value,MAX_FORMSIZE))) { // decode data, ignore empty strings
                     	clrlims();
                        rhhi=atoi(buffer);
                        tlo=aux[0];
                        thi=aux[1];
                        t2hi=aux[2];
                        rhlo=aux[3];
                        dolims();
                        err=0;
					 	   }
						}
					}
				}
			}
		}
      if(err)
			cgi_redirectto(state,REDIRECTTOERR);					// Show error screen
      else
			cgi_redirectto(state,REDIRECTTOK);					// Show OK screen

		return(0);
}





// DATA BUFFERING AND PLOTTING STUFF

#define TCOLOR		35
#define RHCOLOR	210
#define TLCOLOR	21
#define RHLCOLOR	120
#define GRAY		43
#define WHITE		0
#define BLACK		215


#define tscale	127/40.0
#define rhscale 127/80.0
#define rhoffset 10.0

#define dotlim(color)	LCD_line(32,142-(127*tlo)/40,287,142-(127*tlo)/40,color); \
	LCD_line(32,142-(127*thi)/40,287,142-(127*thi)/40,color); \
	LCD_line(32,142-(127*t2hi)/40,287,142-(127*t2hi)/40,color);

#define dorhlim(color) LCD_line(32,142-(127*(rhlo-10))/80,287,142-(127*(rhlo-10))/80,color); \
	LCD_line(32,142-(127*(rhhi-10))/80,287,142-(127*(rhhi-10))/80,color);

// overwrite and or clear grid, need to fix it
void dolims()
{
	dotlim(TLCOLOR);
   dorhlim(RHLCOLOR);
}

void clrlims()
{
	dotlim(WHITE);
   dorhlim(WHITE);
}


void dataplot(int x, int y, unsigned char color)
{
unsigned char data;
unsigned long address;


	if(x>=0 && x<=255 && y>=16 && y<=142) {		// Hardcoded to this screen, sorry
		address=320L*y + 287L-x;
		data=read13706(address);
	   if(data != TLCOLOR && data != RHLCOLOR && data != GRAY) 		// do not overwrite grid
			write13706(address,color);
  	   if(x>0) {		// plot x-1,y
			data=read13706(address+1L);
		   if(data != TLCOLOR && data != RHLCOLOR && data != GRAY) 		// do not overwrite grid
				write13706(address+1L,color);
      }
  	   if(x<255) {		// plot x+1,y
			data=read13706(address-1L);
		   if(data != TLCOLOR && data != RHLCOLOR && data != GRAY) 		// do not overwrite grid
				write13706(address-1L,color);
      }
  	   if(y>16) {		// plot x,y-1
			data=read13706(address-320L);
		   if(data != TLCOLOR && data != RHLCOLOR && data != GRAY) 		// do not overwrite grid
				write13706(address-320L,color);
      }
  	   if(y<142) {		// plot x,y+1
			data=read13706(address+320L);
		   if(data != TLCOLOR && data != RHLCOLOR && data != GRAY) 		// do not overwrite grid
				write13706(address+320L,color);
      }
   }
}

datastuff(float tdata,float rhdata)
{
int i,j,idx;
static unsigned int itbuf[320],irhbuf[320];
unsigned char csvbuf[25];

#GLOBAL_INIT{
	index=0;
   isfull=0;
}

   if(isfull){  					//circular buffer
   	i=j=256;
   }
   else
   	i=j=index;
   while((--i)>=0){                		// clear old plots
   	idx=index-i-1;
      if(idx<0)
      	idx+=256;
		dataplot(i,itbuf[idx],WHITE);
		dataplot(i,irhbuf[idx],WHITE);
   }
	tbuffer[index]=tdata;
	rhbuffer[index]=rhdata;
   itbuf[index]=142-(int)(tscale*tdata);
   irhbuf[index++]=142-(int)(rhscale*(rhdata-rhoffset));
   i=j-isfull;
   do {                		// plot one position to the left + new
   	idx=index-i-1;
      if(idx<0)
      	idx+=256;
		dataplot(i,itbuf[idx],TCOLOR);
		dataplot(i,irhbuf[idx],RHCOLOR);
   } while(i--);
   if(index>=256){
      index=0;
      isfull=1;
   }
}


main()
{
value humi_val,temp_val;
float dew_point;
unsigned char error,checksum;
unsigned int i,j,fan,heater,alarm,config;
long x,y,encoder;

	WrPortI ( PGDDR,&PGDDRShadow,'\B11111111' );
   BitWrPortI (PGDR, &PGDRShadow,1,5);					// no relay
   WrPortI (PFDDR, &PFDDRShadow,PFDDRShadow & ~ '\B00110000');
   WrPortI (PFDR, &PFDRShadow,PFDRShadow & ~ '\B00110000');		// no heater, no fan
	WrPortI ( PEDDR,&PEDDRShadow,'\B10010000' );
   BitWrPortI (PDDR,&PDDRShadow,0,DATA );				// DATA =0
   BitWrPortI (PDDR,&PDDRShadow,0,2 );					// PD2=0
   BitWrPortI (PDDCR, &PDDCRShadow,1,DATA);			// DATA = open drain
	WrPortI ( PDDDR,&PDDDRShadow,'\B11111100' );
	WrPortI ( PBDDR,&PBDDRShadow,'\B11111111' );
	WrPortI ( PBDR,&PBDRShadow,'\B11000000' );
	WrPortI ( PCDR,&PCDRShadow,'\B11101110' );		// AB16=0, M/R = M

	WrPortI(PEFR, &PEFRShadow, (PEFRShadow|0x80));			// enable relay control
	WrPortI(PEDDR, &PEDDRShadow, (PEDDRShadow|0x80));
	WrPortI(IB7CR, &IB7CRShadow, 0x08);
	WrPortI(PECR, &PECRShadow, (PECRShadow & ~0xFF));
  	WrPortE(0xFFFF,NULL,0x00);										// alarm off


// Use Port E bit 4 for Chip Select with 15 wait-states
#define STROBE			0x10
#define CSREGISTER	IB4CR
#define CSSHADOW		IB4CRShadow
#define CSCONFIG		0x08

	// Initialize Port E bit to be a normal I/O pin
	WrPortI(PEFR, &PEFRShadow, (PEFRShadow|STROBE));

	// Initialize Port E bit to be an output pin
	WrPortI(PEDDR, &PEDDRShadow, (PEDDRShadow|STROBE));

	// Initialize Port E bit to be a chip select.
	WrPortI(CSREGISTER, &CSSHADOW, CSCONFIG);

	// Set Port E bit to be clocked by PCLK/2
	WrPortI(PECR, &PECRShadow, (PECRShadow & ~0xFF));

	pwm_init(10000L);
   pwm_set(0,0,0);
   pwm_set(1,0,0);
   sock_init();
   http_init();
   tcp_reserveport(80);
	init13706();
   LCD_dump(frente,palette);
   LCD_icon(ledoff,33,174,58,58);
   LCD_icon(ledoff,101,174,58,58);
   LCD_icon(button0,230,185,60,36);
   BitWrPortI(PCDR,&PCDRShadow,0,2);					// M/R=0 => registers
  	write13706(0xADL,0x80);									// turn display on
   BitWrPortI(PCDR,&PCDRShadow,1,2);					// M/R=1 => memory
   config=0;
   ambisi=0;
   x=160;
   y=120;

	thi=28;
   t2hi=38;
   tlo=12;
   rhhi=78;
   rhlo=22;
   fan=heater=0;
   dolims();
	s_connectionreset();
   while(!config){
      http_handler();						// TCP/IP stuff
   	if(alarm)
	   	WrPortE(0xFFFF,NULL,0x0F);
      else
	   	WrPortE(0xFFFF,NULL,0x00);
	  costate {
			error=0;
			wfd i=s_measure((unsigned char*) &humi_val.i,&checksum,HUMI);  //measure humidity
			error+=i;
			wfd i=s_measure((unsigned char*) &temp_val.i,&checksum,TEMP);  //measure temperature
			error+=i;
			if(error!=0) {
         	printf("\nError, resetting...\n");
         	s_connectionreset();                 //in case of an error: connection reset
         }
			else {
         	humi_val.f=(float)humi_val.i;                   //converts integer to float
				temp_val.f=(float)temp_val.i;                   //converts integer to float
				calc_sht11(&humi_val.f,&temp_val.f);            //calculate humidity, temperature
				dew_point=calc_dewpoint(humi_val.f,temp_val.f); //calculate dew point
				printf("temperature: %5.1fC, humidity: %5.1f%%, dew point: %5.1fC\r",temp_val.f,humi_val.f,dew_point);
            curT=temp_val.f;
            curRH=humi_val.f;
			}
    //----------wait approx 1s to avoid heating up SHTxx------------------------------
			waitfor(DelaySec(1));
     }
     costate {
		// main control loop
      	if(curT>=thi){
         	heater=0;
         	fan=(int)(FAN_MIN+((FAN_MAX-FAN_MIN)*(curT-thi))/(t2hi-thi));
            if(fan>FAN_MAX)
            	fan=FAN_MAX;
         	if(curT>=t2hi)      	//alarma
               alarm=1;
			}
			else {
         	fan=alarm=0;
	         if(curT<=tlo){
      	   	heater=(int)(HEATER_MIN+((HEATER_MAX-HEATER_MIN)*(tlo-curT))/10);
         	   if(heater>HEATER_MAX)
             		heater=HEATER_MAX;
            }
	         else heater=0;
			}

  	      pwm_set(0,fan,0);
	      pwm_set(1,heater,0);
         while(ambisi)												// delay buffer update is data
        	  	  	yield;												// is being served
	      datastuff(curT,curRH);
			waitfor(DelayMs(1000)); // update every second
	}
		costate {   				// handle blinking LEDs
      	if(fan){
	   		LCD_icon(ledon,101,174,58,58);
	   		waitfor(DelayMs(500));
			   LCD_icon(ledoff,101,174,58,58);
   			waitfor(DelayMs(500));
         }

      	if(heater){
	   		LCD_icon(ledon,33,174,58,58);
	   		waitfor(DelayMs(500));
			   LCD_icon(ledoff,33,174,58,58);
   			waitfor(DelayMs(500));
         }
	   }
   }
   pwm_set(0,0,0);
   pwm_set(1,0,0);
  	WrPortE(0xFFFF,NULL,0x00);
}

